//****************
// Bulletbp[
//****************
/*
(Ql) Monshóu񂵂̑v  http://monsho.hp.infoseek.co.jp/
*/

#include	"BulletPhysics.h"


cBulletPhysics			g_clBulletPhysics;


//================
// RXgN^
//================
cBulletPhysics::cBulletPhysics( void ) : m_pBtCollisionConfig( NULL ), m_pBtCollisionDispatcher( NULL ), m_pBtOverlappingPairCache( NULL ),
												m_pBtSolver( NULL ), m_pBtWorld( NULL ), m_pBtGroundShape( NULL )
{
}

//==============
// fXgN^
//==============
cBulletPhysics::~cBulletPhysics( void )
{
	release();
}

//========
// 
//========
bool cBulletPhysics::initialize( void )
{
	// RWRtBO쐬
	m_pBtCollisionConfig = new btDefaultCollisionConfiguration();

	// RWfBXpb`쐬
	m_pBtCollisionDispatcher = new btCollisionDispatcher( m_pBtCollisionConfig );

	// RW[h̍őTCYw肷
	btVector3	btv3WorldAabbMin( -3000.0f, -3000.0f, -3000.0f );
	btVector3	btv3WorldAabbMax(  3000.0f,  3000.0f,  3000.0f );
	int			iMaxProxies = 1024;
	m_pBtOverlappingPairCache = new btAxisSweep3( btv3WorldAabbMin, btv3WorldAabbMax, iMaxProxies );

	// ̍SvZ\o쐬
	m_pBtSolver = new btSequentialImpulseConstraintSolver();

	// [h̍쐬
	m_pBtWorld = new btDiscreteDynamicsWorld( m_pBtCollisionDispatcher, m_pBtOverlappingPairCache, m_pBtSolver, m_pBtCollisionConfig );

	// d͐ݒ
	m_pBtWorld->setGravity( btVector3( 0.0f, -9.8f * 2.0f, 0.0f ) );	// lN^CȂǂӂӂ킷̂łȂƂȂ2{Ă

	//-----------------------------------------------------
	// pƂĖʂ쐬
	m_pBtGroundShape = new btStaticPlaneShape( btVector3( 0.0f, 1.0f, 0.0f ), 0.0f );

	// ̃gXtH[ݒ
	btTransform		trGroundTransform;
	trGroundTransform.setIdentity();

	// MotionState쐬B̂̎p
	btMotionState	*pMotionState = new btDefaultMotionState( trGroundTransform );

	// ̂쐬
	//  0.0Ae\ 0.0 Ȃ炱͓̍̂Ȃ
	btRigidBody::btRigidBodyConstructionInfo	rbInfo( 0.0f, pMotionState, m_pBtGroundShape, btVector3( 0.0f, 0.0f, 0.0f ) );
	btRigidBody		*pRigidBody = new btRigidBody( rbInfo );

	// [hɏǉ
	m_pBtWorld->addRigidBody( pRigidBody );

	return true;
}

//======================
// ̂[hɒǉ
//======================
void cBulletPhysics::addToWorld( btRigidBody *pbtRB, unsigned short unGroupIdx, unsigned short unGroupMask )
{
	m_pBtWorld->addRigidBody( pbtRB, unGroupIdx, unGroupMask );
}

//==================================
// RXgCg[hɒǉ
//==================================
void cBulletPhysics::addToWorld( btTypedConstraint *pctConstraint )
{
	m_pBtWorld->addConstraint( pctConstraint );
}

//========================
// ̂[h폜
//========================
void cBulletPhysics::removeFromWorld( btRigidBody *pbtRB )
{
	m_pBtWorld->removeCollisionObject( pbtRB );
}

//====================================
// RXgCg[h폜
//====================================
void cBulletPhysics::removeFromWorld( btTypedConstraint *pctConstraint )
{
	m_pBtWorld->removeConstraint( pctConstraint );
}

//======
// XV
//======
void cBulletPhysics::update( float fElapsedFlame )
{
	float	fMilliSec = fElapsedFlame * (1000.0f / 30.0f);
//	float	fSubStep = fMilliSec * 0.06f;	// fMilliSec / (1000.0f / 60.0f)

//	m_pBtWorld->stepSimulation( fMilliSec, 1 * (int)fSubStep );
	m_pBtWorld->stepSimulation( fMilliSec, 1, fElapsedFlame / 30.0f );
}

//======
// 
//======
void cBulletPhysics::release( void )
{
	if( !m_pBtWorld )	return;

	for( int i = m_pBtWorld->getNumCollisionObjects() - 1 ; i >= 0 ; i-- )
	{
		btCollisionObject	*pObj = m_pBtWorld->getCollisionObjectArray()[i];
		btRigidBody			*pRigidBody = btRigidBody::upcast( pObj );

		if( pRigidBody && pRigidBody->getMotionState() )	delete pRigidBody->getMotionState();

		m_pBtWorld->removeCollisionObject( pObj );

		delete pObj;
	}

	if( m_pBtGroundShape )
	{
		delete m_pBtGroundShape;
		m_pBtGroundShape = NULL;
	}

	if( m_pBtWorld )
	{
		delete m_pBtWorld;
		m_pBtWorld = NULL;
	}

	if( m_pBtSolver )
	{
		delete m_pBtSolver;
		m_pBtSolver = NULL;
	}

	if( m_pBtOverlappingPairCache )
	{
		delete m_pBtOverlappingPairCache;
		m_pBtOverlappingPairCache = NULL;
	}

	if( m_pBtCollisionDispatcher )
	{
		delete m_pBtCollisionDispatcher;
		m_pBtCollisionDispatcher = NULL;
	}

	if( m_pBtCollisionConfig )
	{
		delete m_pBtCollisionConfig;
		m_pBtCollisionConfig = NULL;
	}
}
